

<html style="height: auto;" class="" lang="en">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<meta http-equiv="x-ua-compatible" content="ie=edge">
		<title class="translate">RAM Machine Simulator</title>
		<link rel="stylesheet" href="codemirror-5.56.0/lib/codemirror.css">
		<link rel="stylesheet" href="codemirror-5.56.0/addon/dialog/dialog.css">
		<link rel="stylesheet" href="codemirror-5.56.0/addon/hint/show-hint.css">
		<link rel="stylesheet" href="codemirror-5.56.0/addon/lint/lint.css">
		<link rel="stylesheet" href="codemirror-5.56.0/addon/search/matchesonscrollbar.css">
		<link rel="stylesheet" href="codemirror-5.56.0/mode/ram_machine/ram_machine-mode.css">
		<!-- Font Awesome Icons -->
		<link rel="stylesheet" href="AdminLTE-3.0.5/plugins/fontawesome-free/css/all.min.css">
		<!-- bootstrap slider -->
		<link rel="stylesheet" href="AdminLTE-3.0.5/plugins/bootstrap-slider/css/bootstrap-slider.min.css">
		<!-- Theme style -->
    <link rel="stylesheet" href="AdminLTE-3.0.5/dist/css/adminlte.min.css">
    <link rel="stylesheet" href="flag-icon-css-3.5.0/css/flag-icon.min.css">
		<link rel="stylesheet" href="crapotca/css/ram_machine.css">
		<!-- REQUIRED SCRIPTS -->
		<!-- jQuery -->
		<script src="AdminLTE-3.0.5/plugins/jquery/jquery.min.js"></script>
		<!-- jQuery UI 1.11.4 -->
		<script src="AdminLTE-3.0.5/plugins/jquery-ui/jquery-ui.min.js"></script>
		<!-- Resolve conflict in jQuery UI tooltip with Bootstrap tooltip -->
		<script>
			$.widget.bridge('uibutton', $.ui.button)
		</script>
		<!-- Bootstrap -->
		<script src="AdminLTE-3.0.5/plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
		<!-- AdminLTE -->
		<script src="AdminLTE-3.0.5/dist/js/adminlte.js"></script>
		<!-- Bootstrap slider -->
		<script src="AdminLTE-3.0.5/plugins/bootstrap-slider/bootstrap-slider.min.js"></script>
		<!-- bs-custom-file-input -->
		<script src="AdminLTE-3.0.5/plugins/bs-custom-file-input/bs-custom-file-input.min.js"></script>
		<script src="codemirror-5.56.0/lib/codemirror.js"></script>
		<script src="codemirror-5.56.0/addon/scroll/annotatescrollbar.js"></script>
		<script src="codemirror-5.56.0/addon/selection/active-line.js"></script>
		<script src="codemirror-5.56.0/addon/display/placeholder.js"></script>  
		<script src="codemirror-5.56.0/addon/dialog/dialog.js"></script>
		<script src="codemirror-5.56.0/addon/search/matchesonscrollbar.js"></script>
		<script src="codemirror-5.56.0/addon/search/searchcursor.js"></script>
		<script src="codemirror-5.56.0/addon/search/search.js"></script>
		<script src="codemirror-5.56.0/addon/search/jump-to-line.js"></script>
		<script src="codemirror-5.56.0/keymap/sublime.js"></script>
		<script src="codemirror-5.56.0/addon/hint/show-hint.js"></script>
		<script src="codemirror-5.56.0/addon/hint/ram_machine-hint.js"></script>
		<script src="codemirror-5.56.0/addon/lint/lint.js"></script>
		<script src="codemirror-5.56.0/addon/lint/ram_machine-lint.js"></script>
		<script src="codemirror-5.56.0/mode/ram_machine/ram_machine-mode.js"></script>
    <script src="jquery.tr/jquery.tr.min.js"></script>
		<script src="js.cookie/js.cookie.min.js"></script>
		<script src="crapotca/js/ram_machine.js"></script>
		<script src="crapotca/js/translate.js"></script>
		<script src="crapotca/js/misc.js"></script>
		<script src="crapotca/js/input.js"></script>
		<script src="crapotca/js/output.js"></script>
		<script src="crapotca/js/program.js"></script>
		<script src="crapotca/js/register.js"></script>
		<script src="crapotca/js/history.js"></script>
		<script src="crapotca/js/cost.js"></script>
	</head>
	<body>
		<div class="wrapper">
			<!-- Content Wrapper. Contains page content -->
			<div class="content-wrapper">
				<!-- Content Header (Page header) -->
				<div class="content-header">
					<div class="container-fluid">
						<div class="row mb-2">
							<div class="col-sm-6">
								<h1 class="m-0 text-dark translate">RAM Machine Simulator</h1>
							</div>
							<!-- /.col -->
							<div class="col-sm-6">
								<ol class="breadcrumb float-sm-right">
									<li class="breadcrumb-item">
                    <button id="language-preview" type="button" class="btn btn-tool dropdown-toggle translate" data-toggle="dropdown" title="English">
                      <i class="flag-icon flag-icon-us"></i>
                    </button>
                    <div id="language-menu" class="dropdown-menu dropdown-menu-right" role="menu">
                      <button id="language-en" class="dropdown-item" language="en">
                        <i class="flag-icon flag-icon-us mr-2"></i>
                        <span class="translate">English</span>
                      </button>
                    <div class="dropdown-divider"></div>
                      <button id="language-it" class="dropdown-item" language="it">
                        <i class="flag-icon flag-icon-it mr-2"></i>
                        <span class="translate">Italian</span>
                      </button>
                    </div>
                  </li>
									<li class="breadcrumb-item">
                    <a href="https://www.linkedin.com/in/ion-crapotca/" target="_B">Ion Crapotca</a>
                  </li>
									<li class="breadcrumb-item">732704</li>
								</ol>
							</div>
							<!-- /.col -->
						</div>
						<!-- /.row -->
					</div>
					<!-- /.container-fluid -->
				</div>
				<!-- /.content-header -->
				<!-- Main content -->
				<div class="content">
					<div class="container-fluid">
						<div class="row">
							<div class="col-sm-12">
                <div class="card bg-light">
                  <div class="overlay d-flex justify-content-center align-items-center dark">
                    <i class="fas fa-2x fa-sync-alt fa-spin" ></i>
                  </div>
                  <div class="card-body">
                    <div class="row">
                      <div class="col-sm-4">
                        <div class="card card-dark card-outline h-100">
                          <div class="overlay d-flex justify-content-center align-items-center dark">
                            <i class="fas fa-2x fa-sync-alt fa-spin" ></i>
                          </div>
                          <div class="card-header border-1 border-bottom">
                            <h3 class="card-title" data-card-widget="collapse">
                              <i class="fas fa-code"></i>
                              <span class="translate">Program</span>
                            </h3>
                            <div id="div-program-tools" class="card-tools hideWhenRunning">
                              <button id="btn-program-empty" class="btn btn-tool btn-sm translate" data-toggle="tooltip" title="Clean">
                              <i class="fas fa-broom"></i>
                              </button>
                              <span class="translate" data-toggle="tooltip" title="Upload">
                              <button id="btn-program-upload" class="btn btn-tool btn-sm" data-toggle="modal" data-target="#file-program-modal">
                              <i class="fas fa-upload"></i>
                              </button>
                              </span>
                              <button id="btn-program-download" class="btn btn-tool btn-sm translate" data-toggle="tooltip" title="Download">
                              <i class="fas fa-download"></i>
                              </button>
                              <span data-toggle="dropdown">
                              <button type="button" class="btn btn-tool dropdown-toggle translate" data-toggle="tooltip" title="Examples">
                              <i class="fas fa-laptop-code"></i>
                              </button>
                              </span>
                              <div class="dropdown-menu dropdown-menu-right" role="menu">
                                <button id="btn-program-example1" class="dropdown-item">
                                <span>
                                <i class="fas fa-file-code"></i>
                                </span>
                                <span class="translate">Example 1</span>
                                </button>
                                <button id="btn-program-example2" class="dropdown-item">
                                <span>
                                <i class="fas fa-file-code"></i>
                                </span>
                                <span class="translate">Example 2</span>
                                </button>
                                <button id="btn-program-example3" class="dropdown-item">
                                <span>
                                <i class="fas fa-file-code"></i>
                                </span>
                                <span class="translate">Example 3</span>
                                </button>
                                <button id="btn-program-example4" class="dropdown-item">
                                <span>
                                <i class="fas fa-file-code"></i>
                                </span>
                                <span class="translate">Example 4</span>
                                </button>
                              </div>
                            </div>
                          </div>
                          <div id="program-body" class="card-body p-0">
                            <textarea id="textarea-program" class="translate" placeholder="Source code goes here..."></textarea>
                          </div>
                        </div>
                        <!-- /.card -->
                      </div>
                      <div class="col-sm-8">  
                        <div class="row">   
                          <div class="col-sm-4">
                            <div class="card card-dark card-outline h-100">
                              <div class="card-header border-1 border-bottom">
                                <h3 class="card-title" data-card-widget="collapse">
                                  <i class="fas fa-book"></i>
                                  <span class="translate">Read tape</span>
                                </h3>
                                <div id="div-input-tools" class="card-tools hideWhenRunning">
                                  &nbsp;
                                  <div class="btn-group">
                                    <button type="button" class="btn btn-tool" data-toggle="dropdown">
                                    <i class="fas fa-ellipsis-v"></i>
                                    </button>
                                    <div class="dropdown-menu dropdown-menu-right" role="menu">
                                      <button id="btn-input-start-edit" class="dropdown-item">
                                      <span>
                                      <i class="fas fa-edit"></i>
                                      </span>
                                      <span class="translate">Modify</span>
                                      </button>
                                      <div class="dropdown-divider"></div>
                                      <button id="btn-input-clean" class="dropdown-item">
                                      <span>
                                      <i class="fas fa-broom"></i>
                                      </span>
                                      <span class="translate">Clean</span>
                                      </button>
                                      <div class="dropdown-divider"></div>
                                      <button id="btn-input-upload" class="dropdown-item" data-toggle="modal" data-target="#file-input-modal">
                                      <span>
                                      <i class="fas fa-upload"></i>
                                      </span>
                                      <span class="translate">Upload</span>
                                      </button>
                                      <div class="dropdown-divider"></div>
                                      <button id="btn-input-download" class="dropdown-item">
                                      <span>
                                      <i class="fas fa-download"></i>
                                      </span>
                                      <span class="translate">Download</span>
                                      </button>
                                    </div>
                                  </div>
                                </div>
                              </div>
                              <div id="input-body" class="card-body">
                                <ul id="edit-input-list" class="todo-list mb-2" data-widget="todo-list"></ul>
                                <div id="edit-input-buttons-container" class="row justify-content-md-center">
                                  <div class="col-sm-6">
                                    <button id="btn-input-abort-edit" class="btn btn-block btn-outline-danger btn-lg translate" data-toggle="tooltip" title="Abort changes">
                                    <i class="fas fa-times"></i>
                                    </button>
                                  </div>
                                  <div class="col-sm-6">    
                                    <button id="btn-input-save-edit" class="btn btn-block btn-outline-success btn-lg translate" data-toggle="tooltip" title="Save changes">
                                    <i class="fas fa-check"></i>
                                    </button>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <!-- /.card -->
                          </div>
                          <div class="col-sm-4">
                            <div class="card card-dark card-outline h-100">
                              <div class="card-header border-1 border-bottom">
                                <h3 class="card-title" data-card-widget="collapse">
                                  <i class="fas fa-memory"></i>
                                  <span class="translate">Registers</span>
                                </h3>
                                <div class="card-tools hideWhenRunning">
                                  &nbsp;
                                  <div class="btn-group">
                                    <button type="button" class="btn btn-tool" data-toggle="dropdown">
                                      <i class="fas fa-ellipsis-v"></i>
                                    </button>
                                    <div class="dropdown-menu dropdown-menu-right" role="menu">
                                      <div class="custom-control custom-switch custom-switch-off-light custom-switch-on-dark dropdown-item">
                                        <div class="pl-2">
                                          <input type="checkbox" class="custom-control-input" id="switchCounters">
                                          <label class="custom-control-label translate" for="switchCounters">Show counter</label>
                                        </div>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                              </div>
                              <div id="registers-body" class="card-body">
                                <div id="counters-container" class="row justify-content-md-center border-bottom mb-3">
                                  <div class="col-sm-4 mb-3">
                                    <div class="counter-container current-location-pointer">
                                      <input id="counter-value-location" class="counter-value form-control" type="text" value="1" readonly>
                                      <span class="counter-index badge badge-dark translate">LC</span>
                                    </div>
                                  </div>
                                  <div class="col-sm-4 mb-3">
                                    <div class="counter-container current-read-pointer">
                                      <input id="counter-value-read" class="counter-value form-control" type="text" value="1" readonly>
                                      <span class="counter-index badge badge-dark translate">R</span>
                                    </div>
                                  </div>
                                  <div class="col-sm-4 mb-3">
                                    <div class="counter-container current-write-pointer">
                                      <input id="counter-value-write" class="counter-value form-control" type="text" value="1" readonly>
                                      <span class="counter-index badge badge-dark translate">W</span>
                                    </div>
                                  </div>
                                </div>
                              </div>
                            </div>
                            <!-- /.card -->
                          </div>
                          <div class="col-sm-4">
                            <div class="card card-dark card-outline h-100">
                              <div class="card-header border-1 border-bottom">
                                <h3 class="card-title" data-card-widget="collapse">
                                  <i class="fas fa-pen-alt"></i>
                                  <span class="translate">Write tape</span>
                                </h3>
                                <div class="card-tools hideWhenRunning">
                                  &nbsp;
                                  <button id="btn-output-download" class="btn btn-tool btn-sm translate" data-toggle="tooltip" title="Download">
                                  <i class="fas fa-download"></i>
                                  </button>
                                </div>
                              </div>
                              <div id="output-body" class="card-body">
                              </div>
                            </div>
                            <!-- /.card -->
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
							</div>
						</div>
						<!-- /.row -->
						<div class="row justify-content-center pb-3">
              <div class="col-sm-4 showWhenRunning">
                <div class="card card-dark card-outline h-100">
                  <div class="card-header">
                    <h3 class="card-title">
                      <i class="fas fa-money-bill-wave-alt"></i>
                      <span class="translate">Uniform Cost</span>
                    </h3>
                    <div class="card-tools">
                      &nbsp;
                    </div>
                  </div>
                  <div class="card-body">
                    <div class="row">
                      <div class="col-sm-6">
                        <div class="card">
                          <div class="card-header">
                            <h3 class="card-title">
                              <i class="fas fa-clock"></i>
                              <span class="translate">Time</span>
                            </h3>
                          </div>
                          <div id="cost-time-uniform" class="card-body">
                          </div>
                        </div>
                      </div>
                      <div class="col-sm-6">
                        <div class="card">
                          <div class="card-header">
                            <h3 class="card-title">
                              <i class="fas fa-ruler"></i>
                              <span class="translate">Space</span>
                            </h3>
                          </div>
                          <div id="cost-space-uniform" class="card-body">
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
							<div class="col-sm-4">
								<div class="card card-dark card-outline h-100">
									<div class="overlay d-flex justify-content-center align-items-center dark">
										<i class="fas fa-2x fa-sync-alt fa-spin" ></i>
									</div>
									<div id="div-status" class="card-header border-1 border-bottom"">
										<h3 class="card-title">
											<i class=""></i>
											<span class="translate">&nbsp;</span>
										</h3>
										<div id="div-status-tools" class="card-tools">
											<i class="fas fa-hourglass-start"></i>
											<span id="status-timer">0</span>
										</div>
									</div>
									<div class="card-body">
										<div class="text-center mb-1">
											<button id="btn-play" class="btn btn-app bg-gradient-dark">
											<i class="fas fa-play"></i>
											<span class="translate">Run</span>
											</button>
											<button id="btn-step" class="btn btn-app bg-gradient-dark">
											<i class="fas fa-step-forward"></i>
											<span class="translate">Step</span>
											</button>
											<button id="btn-pause" class="btn btn-app bg-gradient-dark" style="display:none;">
											<i class="fas fa-pause"></i>
											<span class="translate">Pause</span>
											</button>
											<button id="btn-stop" class="btn btn-app bg-gradient-dark" style="display:none;">
											<i class="fas fa-stop"></i>
											<span class="translate">Stop</span>
											</button>
											<button id="btn-reset" class="btn btn-app bg-gradient-dark">
											<i class="fas fa-redo"></i>
											<span class="translate">Reset</span>
											</button>
										</div>
										<div class="text-center mb-2 translate">
											Steps delay (in seconds)
										</div>
										<div class="row justify-content-md-center">
											<div class="col-sm-10">
												<input
													id="slider"
													type="number"
													data-provide="slider"
													data-slider-ticks="[0, 1, 2, 5, 10, 15, 30, 45, 60]"
													data-slider-ticks-positions="[0, 12.5, 25, 37.5, 50, 62.5, 75, 87.5, 100]"
													data-slider-ticks-labels='["0", "1", "2", "5", "10", "15", "30", "45", "60"]'
													data-slider-selection="none"
													data-slider-tooltip-position="bottom"
													/>
											</div>
										</div>
									</div>
								</div>
              </div>
              <div class="col-sm-4 showWhenRunning">
                <div class="card card-dark card-outline h-100">
                  <div class="card-header">
                    <h3 class="card-title">
                      <i class="fas fa-money-bill-wave"></i>
                      <span class="translate">Logarithmic Cost</span>
                    </h3>
                    <div class="card-tools">
                      &nbsp;
                    </div>
                  </div>
                  <div class="card-body">
                    <div class="row">
                      <div class="col-sm-6">
                        <div class="card">
                          <div class="card-header">
                            <h3 class="card-title">
                              <i class="fas fa-clock"></i>
                              <span class="translate">Time</span>
                            </h3>
                          </div>
                          <div id="cost-time-logarithmic" class="card-body">
                          </div>
                        </div>
                      </div>
                      <div class="col-sm-6">
                        <div class="card">
                          <div class="card-header">
                            <h3 class="card-title">
                              <i class="fas fa-ruler"></i>
                              <span class="translate">Space</span>
                            </h3>
                          </div>
                          <div id="cost-space-logarithmic" class="card-body">
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row justify-content-center">
              <div class="col-sm-9 showWhenRunning">
								<div class="card card-dark card-outline">
									<div class="card-header">
										<h3 class="card-title" data-card-widget="collapse">
											<i class="fas fa-history"></i>
											<span class="translate">Call Stack</span>
                    </h3>
                    <div class="card-tools">
                      &nbsp;
                      <div class="btn-group">
                        <button type="button" class="btn btn-tool" data-toggle="dropdown">
                          <i class="fas fa-ellipsis-v"></i>
                        </button>
                        <div class="dropdown-menu dropdown-menu-right" role="menu">
                          <div class="custom-control custom-switch custom-switch-off-light custom-switch-on-dark dropdown-item">
                            <div class="pl-2">
                              <input type="checkbox" class="custom-control-input" id="switchChanges">
                              <label class="custom-control-label translate" for="switchChanges">Show changes</label>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
									</div>
									<div id="history-body" class="card-body table-responsive p-0">
										<table class="table table-head-fixed table-striped table-hover text-nowrap">
											<thead>
												<tr>
													<th class="translate" style="width: 10px">Line</th>
													<th class="translate">Label</th>
													<th class="translate">Op. Code</th>
													<th class="translate">Operand</th>
													<th class="translate changes" style="text-align:center;">Changes</th>
												</tr>
											</thead>
											<tbody id="history-table-body">
											</tbody>
										</table>
									</div>
								</div>
              </div>
            </div>
					</div>
					<!-- /.container-fluid -->
				</div>
				<!-- /.content -->
			</div>
			<!-- /.content-wrapper -->
		</div>
		<div id="file-input-modal" class="modal fade">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h4 class="modal-title translate">Select a file to fill the read tape</h4>
						<button type="button" class="close" data-dismiss="modal">
						<span>&times;</span>
						</button>
					</div>
					<div class="modal-body">
						<div class="custom-file mb-2">
							<input id="file-input" type="file" class="custom-file-input" accept="text/plain">
							<label class="custom-file-label translate" for="file-input">Choose input file</label>
						</div>
						<span class="text translate">Each line of the file must have an integer value</span>
					</div>
					<div class="modal-footer justify-content-between">
						<button type="button" class="btn btn-default translate" data-dismiss="modal">Cancel</button>
						<button id="btn-input-upload-confirm" type="button" class="btn btn-success translate">Upload</button>
					</div>
				</div>
				<!-- /.modal-content -->
			</div>
			<!-- /.modal-dialog -->
		</div>
		<!-- /.modal -->
		<div id="file-program-modal" class="modal fade">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h4 class="modal-title translate">Select a source file</h4>
						<button type="button" class="close" data-dismiss="modal">
						<span>&times;</span>
						</button>
					</div>
					<div class="modal-body">
						<div class="custom-file mb-2">
							<input id="file-program" type="file" class="custom-file-input" accept="text/plain">
							<label class="custom-file-label translate" for="file-program">Choose source file</label>
						</div>
					</div>
					<div class="modal-footer justify-content-between">
						<button type="button" class="btn btn-default translate" data-dismiss="modal">Cancel</button>
						<button id="btn-program-upload-confirm" type="button" class="btn btn-success translate">Upload</button>
					</div>
				</div>
				<!-- /.modal-content -->
			</div>
			<!-- /.modal-dialog -->
		</div>
		<!-- /.modal -->
		<!-- Main Footer -->
		<footer class="main-footer">
      <div class="row">
        <div class="col-sm-4">
          <a href="https://www.uninsubria.it/">
            <span class="translate">University of Insubria</span>
          </a>
        </div>
        <div class="col-sm-4">
          <a href="https://gitlab.com/crapotca.ion22/ram-machine-simulator" target="_B" title="GitLab">
            <button type="button" class="btn btn-outline-dark btn-sm">
              <svg width="24" height="24" class="tanuki-logo" viewBox="0 0 36 36">
                <path class="tanuki-shape tanuki-left-ear" fill="#e24329" d="M2 14l9.38 9v-9l-4-12.28c-.205-.632-1.176-.632-1.38 0z"></path>
                <path class="tanuki-shape tanuki-right-ear" fill="#e24329" d="M34 14l-9.38 9v-9l4-12.28c.205-.632 1.176-.632 1.38 0z"></path>
                <path class="tanuki-shape tanuki-nose" fill="#e24329" d="M18,34.38 3,14 33,14 Z"></path>
                <path class="tanuki-shape tanuki-left-eye" fill="#fc6d26" d="M18,34.38 11.38,14 2,14 6,25Z"></path>
                <path class="tanuki-shape tanuki-right-eye" fill="#fc6d26" d="M18,34.38 24.62,14 34,14 30,25Z"></path>
                <path class="tanuki-shape tanuki-left-cheek" fill="#fca326" d="M2 14L.1 20.16c-.18.565 0 1.2.5 1.56l17.42 12.66z"></path>
                <path class="tanuki-shape tanuki-right-cheek" fill="#fca326" d="M34 14l1.9 6.16c.18.565 0 1.2-.5 1.56L18 34.38z"></path>
              </svg>
              <span>&nbsp;</span>
              <span class="translate">Source Code</span>
            </button>            
          </a>
        </div>
        <div class="col-sm-4">
          <span class="translate">First cycle degree in computer science</span>
        </div>
      </div>
		</footer>
	</body>
</html>

